## nghttp2 1.64.0

=== src/CMakeLists.txt ===
file(GLOB c_sources *.c)
set_source_files_properties(${c_sources} PROPERTIES
  COMPILE_FLAGS "${WARNCFLAGS}")
file(GLOB cxx_sources *.cc)
set_source_files_properties(${cxx_sources} PROPERTIES
  COMPILE_FLAGS "${WARNCXXFLAGS} ${CXX1XCXXFLAGS}")

include_directories(
  "${CMAKE_CURRENT_SOURCE_DIR}/includes"
  "${CMAKE_CURRENT_SOURCE_DIR}/../third-party"
  "${CMAKE_CURRENT_SOURCE_DIR}/../third-party/llhttp/include"

  ${JEMALLOC_INCLUDE_DIRS}
  ${LIBXML2_INCLUDE_DIRS}
  ${LIBEV_INCLUDE_DIRS}
  ${LIBNGHTTP3_INCLUDE_DIRS}
  ${LIBNGTCP2_INCLUDE_DIRS}
  ${LIBNGTCP2_CRYPTO_QUICTLS_INCLUDE_DIRS}
  ${LIBNGTCP2_CRYPTO_WOLFSSL_INCLUDE_DIRS}
  ${OPENSSL_INCLUDE_DIRS}
  ${WOLFSSL_INCLUDE_DIRS}
  ${LIBCARES_INCLUDE_DIRS}
  ${JANSSON_INCLUDE_DIRS}
  ${ZLIB_INCLUDE_DIRS}
  ${LIBBPF_INCLUDE_DIRS}
  ${LIBBROTLIENC_INCLUDE_DIRS}
  ${LIBBROTLIDEC_INCLUDE_DIRS}
)

# XXX per-target?
link_libraries(
  nghttp2
  ${JEMALLOC_LIBRARIES}
  ${LIBXML2_LIBRARIES}
  ${LIBEV_LIBRARIES}
  ${LIBNGHTTP3_LIBRARIES}
  ${LIBNGTCP2_LIBRARIES}
  ${LIBNGTCP2_CRYPTO_QUICTLS_LIBRARIES}
  ${LIBNGTCP2_CRYPTO_WOLFSSL_LIBRARIES}
  ${OPENSSL_LIBRARIES}
  ${WOLFSSL_LIBRARIES}
  ${LIBCARES_LIBRARIES}
  ${JANSSON_LIBRARIES}
  ${ZLIB_LIBRARIES}
  ${APP_LIBRARIES}
  ${LIBBPF_LIBRARIES}
  ${LIBBROTLIENC_LIBRARIES}
  ${LIBBROTLIDEC_LIBRARIES}
)

if(ENABLE_APP)
  set(HELPER_OBJECTS
    util.cc
    http2.cc timegm.c app_helper.cc nghttp2_gzip.c
  )

  # nghttp client
  set(NGHTTP_SOURCES
    ${HELPER_OBJECTS}
    nghttp.cc
    tls.cc
  )
  if(HAVE_LIBXML2)
    list(APPEND NGHTTP_SOURCES HtmlParser.cc)
  endif()

  # nghttpd
  set(NGHTTPD_SOURCES
    ${HELPER_OBJECTS}
    nghttpd.cc
    tls.cc
    HttpServer.cc
  )

  # h2load
  set(H2LOAD_SOURCES
    util.cc
    http2.cc h2load.cc
    timegm.c
    tls.cc
    h2load_http2_session.cc
    h2load_http1_session.cc
  )
  if(ENABLE_HTTP3)
    list(APPEND H2LOAD_SOURCES
      h2load_http3_session.cc
      h2load_quic.cc
      quic.cc
    )
  endif()

  # Common libnhttpx sources (used for nghttpx and unit tests)
  set(NGHTTPX_SRCS
    util.cc http2.cc timegm.c
    app_helper.cc
    tls.cc
    shrpx_config.cc
    shrpx_accept_handler.cc
    shrpx_connection_handler.cc
    shrpx_client_handler.cc
    shrpx_http2_upstream.cc
    shrpx_https_upstream.cc
    shrpx_downstream.cc
    shrpx_downstream_connection.cc
    shrpx_http_downstream_connection.cc
    shrpx_http2_downstream_connection.cc
    shrpx_http2_session.cc
    shrpx_downstream_queue.cc
    shrpx_log.cc
    shrpx_http.cc
    shrpx_io_control.cc
    shrpx_tls.cc
    shrpx_worker.cc
    shrpx_log_config.cc
    shrpx_connect_blocker.cc
    shrpx_live_check.cc
    shrpx_downstream_connection_pool.cc
    shrpx_rate_limit.cc
    shrpx_connection.cc
    shrpx_memcached_dispatcher.cc
    shrpx_memcached_connection.cc
    shrpx_worker_process.cc
    shrpx_signal.cc
    shrpx_router.cc
    shrpx_api_downstream_connection.cc
    shrpx_health_monitor_downstream_connection.cc
    shrpx_null_downstream_connection.cc
    shrpx_exec.cc
    shrpx_dns_resolver.cc
    shrpx_dual_dns_resolver.cc
    shrpx_dns_tracker.cc
    xsi_strerror.c
  )
  if(HAVE_MRUBY)
    list(APPEND NGHTTPX_SRCS
      shrpx_mruby.cc
      shrpx_mruby_module.cc
      shrpx_mruby_module_env.cc
      shrpx_mruby_module_request.cc
      shrpx_mruby_module_response.cc
    )
  endif()
  if(ENABLE_HTTP3)
    list(APPEND NGHTTPX_SRCS
     shrpx_quic.cc
     shrpx_quic_listener.cc
     shrpx_quic_connection_handler.cc
     shrpx_http3_upstream.cc
     http3.cc
     quic.cc
    )
  endif()
  add_library(nghttpx_static STATIC ${NGHTTPX_SRCS})
  set_target_properties(nghttpx_static PROPERTIES ARCHIVE_OUTPUT_NAME nghttpx)

  set(NGHTTPX-bin_SOURCES
    shrpx.cc
  )

  if(HAVE_SYSTEMD)
    target_link_libraries(nghttpx_static ${SYSTEMD_LIBRARIES})
    target_compile_definitions(nghttpx_static PUBLIC HAVE_LIBSYSTEMD)
    target_include_directories(nghttpx_static PUBLIC ${SYSTEMD_INCLUDE_DIRS})
  endif()

  if(HAVE_MRUBY)
    target_link_libraries(nghttpx_static mruby-lib)
  endif()

  if(HAVE_NEVERBLEED)
    target_link_libraries(nghttpx_static neverbleed)
  endif()

  set(NGHTTPX_UNITTEST_SOURCES
    shrpx-unittest.cc
    shrpx_tls_test.cc
    shrpx_downstream_test.cc
    shrpx_config_test.cc
    shrpx_worker_test.cc
    shrpx_http_test.cc
    shrpx_router_test.cc
    http2_test.cc
    util_test.cc
    nghttp2_gzip_test.c
    nghttp2_gzip.c
    buffer_test.cc
    memchunk_test.cc
    template_test.cc
    base64_test.cc
    ${CMAKE_SOURCE_DIR}/tests/munit/munit.c
  )
  add_executable(nghttpx-unittest EXCLUDE_FROM_ALL
    ${NGHTTPX_UNITTEST_SOURCES}
    $<TARGET_OBJECTS:llhttp>
    $<TARGET_OBJECTS:url-parser>
    )
  target_include_directories(nghttpx-unittest PRIVATE
    ${CMAKE_SOURCE_DIR}/tests/munit
  )
  target_compile_definitions(nghttpx-unittest
    PRIVATE "-DNGHTTP2_SRC_DIR=\"${CMAKE_SOURCE_DIR}/src\""
  )
  target_link_libraries(nghttpx-unittest nghttpx_static)
  if(HAVE_MRUBY)
    target_link_libraries(nghttpx-unittest mruby-lib)
  endif()
  if(HAVE_NEVERBLEED)
    target_link_libraries(nghttpx-unittest neverbleed)
  endif()

  add_test(nghttpx-unittest nghttpx-unittest)
  add_dependencies(check nghttpx-unittest)

  add_executable(nghttp   ${NGHTTP_SOURCES}   $<TARGET_OBJECTS:llhttp>
    $<TARGET_OBJECTS:url-parser>
  )
  add_executable(nghttpd  ${NGHTTPD_SOURCES}  $<TARGET_OBJECTS:llhttp>
    $<TARGET_OBJECTS:url-parser>
  )
  add_executable(nghttpx  ${NGHTTPX-bin_SOURCES} $<TARGET_OBJECTS:llhttp>
    $<TARGET_OBJECTS:url-parser>
  )
  target_compile_definitions(nghttpx PRIVATE
    "-DPKGDATADIR=\"${PKGDATADIR}\""
    "-DPKGLIBDIR=\"${PKGLIBDIR}\""
  )
  target_link_libraries(nghttpx nghttpx_static)
  add_executable(h2load   ${H2LOAD_SOURCES}   $<TARGET_OBJECTS:llhttp>
    $<TARGET_OBJECTS:url-parser>
  )

  install(TARGETS nghttp nghttpd nghttpx h2load)
endif()

if(ENABLE_HPACK_TOOLS)
  set(inflatehd_SOURCES
    inflatehd.cc
    comp_helper.c
  )
  set(deflatehd_SOURCES
    deflatehd.cc
    comp_helper.c
    util.cc
    timegm.c
  )
  add_executable(inflatehd ${inflatehd_SOURCES})
  add_executable(deflatehd ${deflatehd_SOURCES})
  install(TARGETS inflatehd deflatehd)
endif()

=== tests/CMakeLists.txt ===
# XXX testdata/: EXTRA_DIST = cacert.pem  index.html  privkey.pem
string(REPLACE " " ";" c_flags "${WARNCFLAGS}")
add_compile_options(${c_flags})

include_directories(
  "${CMAKE_SOURCE_DIR}/lib/includes"
  "${CMAKE_SOURCE_DIR}/lib"
  "${CMAKE_SOURCE_DIR}/tests/munit"
  "${CMAKE_BINARY_DIR}/lib/includes"
)

set(MAIN_SOURCES
  main.c nghttp2_pq_test.c nghttp2_map_test.c nghttp2_queue_test.c
  nghttp2_test_helper.c
  nghttp2_frame_test.c
  nghttp2_stream_test.c
  nghttp2_session_test.c
  nghttp2_hd_test.c
  nghttp2_alpn_test.c
  nghttp2_helper_test.c
  nghttp2_buf_test.c
  nghttp2_http_test.c
  nghttp2_extpri_test.c
  nghttp2_ratelim_test.c
  munit/munit.c
)

add_executable(main EXCLUDE_FROM_ALL
  ${MAIN_SOURCES}
)
target_link_libraries(main
  nghttp2_static
)
add_test(main main)
add_dependencies(check main)

if(ENABLE_FAILMALLOC)
  set(FAILMALLOC_SOURCES
    failmalloc.c failmalloc_test.c
    malloc_wrapper.c
    nghttp2_test_helper.c
    munit/munit.c
  )
  add_executable(failmalloc EXCLUDE_FROM_ALL
    ${FAILMALLOC_SOURCES}
  )
  target_link_libraries(failmalloc
    nghttp2_static
  )
  add_test(failmalloc failmalloc)
  add_dependencies(check failmalloc)
endif()

=== debian/changelog ===
nghttp2 (1.64.0-1.1ubuntu1) questing; urgency=medium

  * d/p/lp-2125171-remove-invalid-c23-macro.patch: Fix build with gcc15.
    Thanks to Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>. (LP: #2125171)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Fri, 19 Sep 2025 00:33:01 -0300

nghttp2 (1.64.0-1.1build1) questing; urgency=medium

  * No-change rebuild for libxml2 soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 20 May 2025 12:24:07 +0200

nghttp2 (1.64.0-1.1) unstable; urgency=medium

  * Add patch: lp-2104171-avoid-rubydomain-namespace.patch (Closes: #1095360)

 -- Maximiliano Curia <maxy@debian.org>  Fri, 11 Apr 2025 17:50:32 +0200

nghttp2 (1.64.0-1) unstable; urgency=medium

  * New upstream version 1.64.0

 -- Tomasz Buchert <tomasz@debian.org>  Mon, 28 Oct 2024 20:45:36 +0100

=== debian/control ===
Source: nghttp2
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Tomasz Buchert <tomasz@debian.org>
Uploaders: Ondřej Surý <ondrej@debian.org>
Section: httpd
Priority: optional
Build-Depends: debhelper (>= 13),
               debhelper-compat (= 13),
               libc-ares-dev,
               libcunit1-dev <!nocheck>,
               libev-dev,
               libjansson-dev,
               libjemalloc-dev [!hurd-i386],
               libssl-dev,
               libsystemd-dev,
               libxml2-dev,
               pkgconf,
               zlib1g-dev
Build-Depends-Indep: python3-sphinx, python3-sphinx-rtd-theme
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debian/nghttp2
Vcs-Git: https://salsa.debian.org/debian/nghttp2.git
Homepage: https://nghttp2.org/
Rules-Requires-Root: no

Package: libnghttp2-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libnghttp2-14 (= ${binary:Version}), pkgconf, ${misc:Depends}
Suggests: libnghttp2-doc
Conflicts: libnghttp2-3-dev, libnghttp2-4-dev, libnghttp2-5-dev
Replaces: libnghttp2-3-dev, libnghttp2-4-dev, libnghttp2-5-dev
Description: library implementing HTTP/2 protocol (development files)
 This is an implementation of the Hypertext Transfer Protocol version
 2 in C. The framing layer of HTTP/2 is implemented as a reusable C
 library.
 .
 This package installs development files.

Package: libnghttp2-doc
Architecture: all
Section: doc
Depends: libjs-jquery, libjs-underscore, lynx | www-browser, ${misc:Depends}
Description: library implementing HTTP/2 protocol (documentation)
 This is an implementation of the Hypertext Transfer Protocol version
 2 in C. The framing layer of HTTP/2 is implemented as a reusable C
 library.
 .
 This package installs documentation.

Package: libnghttp2-14
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: library implementing HTTP/2 protocol (shared library)
 This is an implementation of the Hypertext Transfer Protocol version
 2 in C. The framing layer of HTTP/2 is implemented as a reusable C
 library.
 .
 This package installs a shared library.

Package: nghttp2-client
Architecture: any
Multi-Arch: foreign
Depends: libnghttp2-14 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: nghttp2 (<< 1.3.4-2~)
Replaces: nghttp2 (<< 1.3.4-2~)
Description: client implementing HTTP/2 protocol
 This is a command line client implementing the HTTP/2 protocol. It
 gives access to many low-level and advanced aspects of the protocol
 and therefore is useful for debugging.

Package: nghttp2-proxy
Architecture: any
Multi-Arch: foreign
Depends: libnghttp2-14 (= ${binary:Version}),
         openssl,
         python3,
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Breaks: nghttp2 (<< 1.3.4-2~)
Replaces: nghttp2 (<< 1.3.4-2~)
Description: reverse proxy implementing HTTP/2 protocol
 This is a standalone server implementing the HTTP/2 protocol with
 HTTP/1.1 fallback for clients that do not support it. It can be used
 as a frontend in front of web servers that do not support HTTP/2.

Package: nghttp2-server
Architecture: any
Multi-Arch: foreign
Depends: libnghttp2-14 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: nghttp2 (<< 1.3.4-2~)
Replaces: nghttp2 (<< 1.3.4-2~)
Description: server implementing HTTP/2 protocol
 This is a standalone server implementing the HTTP/2 protocol with
 HTTP/1.1 fallback for clients that do not support it. It can be used
 to serve files from a local directory.

Package: nghttp2
Architecture: all
Multi-Arch: foreign
Depends: nghttp2-client (>= ${binary:Version}),
         nghttp2-proxy (>= ${binary:Version}),
         nghttp2-server (>= ${binary:Version}),
         ${misc:Depends}
Description: server, proxy and client implementing HTTP/2
 This package will install a set of programs implementing the HTTP/2
 protocol: a standalone server (nghttp2-server), a reverse proxy
 (nghttp2-proxy) and a client (nghttp2-client). It provides no files
 on its own and is not necessary for these programs to work.

=== debian/rules ===
#!/usr/bin/make -f

# this makes the tests fail
# LDFLAGS += -Wl,--default-symver

override_dh_auto_configure:
	dh_auto_configure -- \
		--enable-python-bindings=no --disable-failmalloc --enable-app

override_dh_auto_build-arch:
	dh_auto_build

override_dh_auto_build-indep:
	$(MAKE) html

# don't run tests when building indep packages
override_dh_auto_test-indep:

override_dh_auto_clean:
	dh_auto_clean
	rm -rf doc/manual/html doc/manual/doctrees doc/apiref.rst

override_dh_auto_install-arch: custom_install_init_scripts custom_install_systemd
	dh_auto_install

override_dh_auto_install-indep: custom_install_manual

override_dh_installinit:
	dh_installinit -pnghttp2-proxy --onlyscripts --name=nghttpx --no-stop-on-upgrade --no-start

override_dh_installsystemd:
	dh_installsystemd --no-restart-after-upgrade --no-stop-on-upgrade --no-start

.PHONY: custom_install_manual custom_install_init_scripts custom_install_systemd

DOCDIR="debian/libnghttp2-doc/usr/share/doc/libnghttp2-doc"
custom_install_manual:
	mkdir -p $(DOCDIR)
	cp -pr doc/manual/html/* $(DOCDIR)
	rm $(DOCDIR)/objects.inv
	ln -sf /usr/share/javascript/jquery/jquery.js $(DOCDIR)/_static/jquery.js
	ln -sf /usr/share/javascript/underscore/underscore.js $(DOCDIR)/_static/underscore.js
	cp -p doc/README.rst $(DOCDIR)

ETCDIR="debian/nghttp2-proxy/etc"
custom_install_init_scripts:
	install -d $(ETCDIR)/init.d
	sed -e 's,^DAEMON=.*/,DAEMON=/usr/sbin/,' contrib/nghttpx-init > $(ETCDIR)/init.d/nghttpx
	chmod 755 $(ETCDIR)/init.d/nghttpx
	install -d $(ETCDIR)/nghttpx
	# we install our own version of config
	install -m644 debian/nghttpx.conf $(ETCDIR)/nghttpx/nghttpx.conf
	install -d $(ETCDIR)/logrotate.d
	install -p -m644 contrib/nghttpx-logrotate $(ETCDIR)/logrotate.d/nghttpx

# Currently we install our own systemd unit because
# the original one is slightly broken
custom_install_systemd:
	dh_installsystemd -pnghttp2-proxy --name nghttpx

%:
	dh $@

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/nghttp2-$1\.tar\.gz/ \
  https://github.com/nghttp2/nghttp2/tags .*/v?(\d\S+)\.tar\.gz

## nghttp2 1.68.0

=== debian/changelog ===
nghttp2 (1.68.0-2) unstable; urgency=medium

  [ Luca Boccassi ]
  * Always use invoke-rc.d when checking status (Closes: #1128487)

 -- Tomasz Buchert <tomasz@debian.org>  Tue, 24 Feb 2026 23:24:40 +0100

nghttp2 (1.68.0-1) unstable; urgency=medium

  * New upstream version 1.68.0
  * Start using signed releases tarballs in favor of tags
  * Remove obsolete patches
  * Removing fetch-ocsp-response -> no longer supported
  * Update copyright to account for source file changes
  * Minor packaging fixes and refreshes

 -- Tomasz Buchert <tomasz@debian.org>  Sat, 07 Feb 2026 15:29:22 +0100

=== debian/watch ===
version=4
opts=downloadurlmangle=s%archive/refs/tags/v(.*)\.tar\.gz%releases/download/v$1/nghttp2-$1\.tar\.gz%,\
  pgpsigurlmangle=s/$/.asc/ \
  https://github.com/nghttp2/nghttp2/tags \
  .*/v?(\d\S+)\.tar\.gz
